var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var typescript_1 = require('typescript');
var stream_1 = require('stream');
var path_1 = require('path');
var CompileTypeScriptPipe = (function (_super) {
    __extends(CompileTypeScriptPipe, _super);
    function CompileTypeScriptPipe() {
        _super.apply(this, arguments);
    }
    CompileTypeScriptPipe.prototype.allows = function (filename) {
        return path_1.extname(filename) == '.ts';
    };
    CompileTypeScriptPipe.prototype.do = function (v) {
        v.input = v.input.pipe(this);
        v.input.setMaxListeners(Infinity);
        var extension = path_1.extname(v.output);
        // Change file extensions to JavaScript
        v.output = v.output.substr(0, v.output.length - extension.length) + '.js';
        return v;
    };
    CompileTypeScriptPipe.prototype._transform = function (chunk, encoding, callback) {
        chunk = typescript_1.transpile(chunk.toString(), { module: 1 /* CommonJS */ });
        this.push(chunk);
        callback();
    };
    return CompileTypeScriptPipe;
})(stream_1.Transform);
exports.CompileTypeScriptPipe = CompileTypeScriptPipe;
function create() {
    return new CompileTypeScriptPipe();
}
exports.create = create;
