var Promise = require('any-promise');
var thenify = require('thenify');
var minimist = require('minimist');
var fs_1 = require('fs');
var path_1 = require('path');
var fs = require('fs');
// `fs.readFile` in promise form, courtesy https://github.com/typings/typings/blob/master/src/utils/fs.ts#L40
exports.readFile = thenify(fs.readFile);
/*
 * Retrieve all of the files within a given folder.
 */
function getFiles(folder) {
    if (folder === void 0) { folder = './'; }
    return new Promise(function (resolve, reject) {
        fs_1.readdir(folder, function (err, files) {
            var promises = files.map(function (filename) {
                return new Promise(function (resolve, reject) {
                    filename = path_1.join(folder, filename);
                    fs_1.stat(filename, function (err, stats) {
                        if (err) {
                            console.log(err);
                            throw err;
                        }
                        if (stats.isDirectory()) {
                            getFiles(filename)
                                .then(function (files) {
                                resolve(files);
                            });
                        }
                        else {
                            resolve([filename]);
                        }
                    });
                });
            });
            Promise.all(promises)
                .then(function (filenames) {
                // Flatten filenames array (string[][] -> string[])
                var files = [].concat.apply([], filenames);
                resolve(files);
            });
        });
    });
}
exports.getFiles = getFiles;
function getArgs(raw) {
    if (raw === void 0) { raw = process.argv.slice(2); }
    return minimist(raw, {
        boolean: ['help'],
        string: ['file'],
        alias: {
            help: ['h'],
            file: ['f']
        }
    });
}
exports.getArgs = getArgs;
